// This file contains a listing of the Major, Minor, Patch and Build numbers
// for Scalix products.
//

#define kScalixReleaseType
#define kScalixMapiReleaseType
#define kScalixMapiSubReleaseType
#define kScalixSwaReleaseType
#define kScalixAdminReleaseType
#define kScalixInstallReleaseType



// These numbers are automatically updated by the build system
#define kScalixMajorNum 11
#define kScalixMinorNum 4
#define kScalixPatchNum 6
#define kScalixBuildNum 83
#define kScalixMapiDepotNumber 9214



// DCB: these macros are used to convert kScalixMajorNum etc into strings
#define xstr_tmp_(s) str_tmp_(s)
#define str_tmp_(s) #s
// so.... xstr_tmp_(kScalixMajorNum) preprocesses to the numerical value of the version number (currently "11")
// See http://gcc.gnu.org/onlinedocs/cpp/Stringification.html



// DCB Use the above macros to get string versions of the values set by the build system
#define kScalixMajorNum_str         xstr_tmp_(kScalixMajorNum)
#define kScalixMinorNum_str         xstr_tmp_(kScalixMinorNum)
#define kScalixPatchNum_str         xstr_tmp_(kScalixPatchNum)
#define kScalixBuildNum_str         xstr_tmp_(kScalixBuildNum)
#define kScalixMapiDepotNumber_str  xstr_tmp_(kScalixMapiDepotNumber)



#define kScalixProductVer kScalixMajorNum,kScalixMinorNum,kScalixPatchNum,kScalixMapiDepotNumber
#define kScalixFileVer kScalixMajorNum,kScalixMinorNum,kScalixPatchNum,kScalixMapiDepotNumber

#define kScalixProdVerStr       "11.4.6.83 " kScalixReleaseType "\0"
#define kScalixFileVerStr       "11.4.6.83 " kScalixReleaseType "\0"


#define kScalixMapiVerStr kScalixMajorNum_str "." kScalixMinorNum_str "." kScalixPatchNum_str "." kScalixMapiDepotNumber_str kScalixMapiReleaseType kScalixMapiSubReleaseType "\0"


#define kScalixMapiProdNameShort "Scalix Connect"

#define kScalixMapiProdName     kScalixMapiProdNameShort " for Microsoft Outlook\0"
#define kScalixMapiCopyrightYr  "2009"
#define kScalixMapiCompany      "Scalix Corporation\0"

#define kScalixCopyrightYr  "2009"
#define kScalixCompany      "Scalix Corporation\0"

