//
// virtual key declarations copied from winuser.h
//
var VK_LBUTTON      = 0x01;
var VK_RBUTTON      = 0x02;
var VK_CANCEL       = 0x03;
var VK_BACK         = 0x08;
var VK_TAB          = 0x09;
var VK_CLEAR        = 0x0C;
var VK_RETURN       = 0x0D;
var VK_SHIFT        = 0x10;
var VK_CONTROL      = 0x11;
var VK_MENU         = 0x12;
var VK_PAUSE        = 0x13;
var VK_CAPITAL      = 0x14;
var VK_KANA         = 0x15;
var VK_FINAL        = 0x18;
var VK_ESCAPE       = 0x1B;
var VK_CONVERT      = 0x1C;
var VK_NONCONVERT   = 0x1D;
var VK_ACCEPT       = 0x1E;
var VK_MODECHANGE   = 0x1F;
var VK_SPACE        = 0x20;
var VK_PRIOR        = 0x21;
var VK_NEXT         = 0x22;
var VK_END          = 0x23;
var VK_HOME         = 0x24;
var VK_LEFT         = 0x25;
var VK_UP           = 0x26;
var VK_RIGHT        = 0x27;
var VK_DOWN         = 0x28;
var VK_SELECT       = 0x29;
var VK_PRINT        = 0x2A;
var VK_EXECUTE      = 0x2B;
var VK_INSERT       = 0x2D;
var VK_DELETE       = 0x2E;
var VK_HELP         = 0x2F;

//
// page enumerations
//
var PAGE_RULESLIST      = 0;
var PAGE_SETUP          = 1;
var PAGE_CONDITIONS     = 2;
var PAGE_ACTIONS        = 3;
var PAGE_EXCEPTIONS     = 4;
var PAGE_MAX            = 5;

//
// getNextCBID flags
//
var CBID_FIRST          = 0;
var CBID_NEXT           = 1;
var CBID_PREV           = 2;

var g_nCurPage = PAGE_MAX;

//
// Key handlers for different pages 
//
function getNextCBID(ncbCur, nFlag) {
    var ncbNext = 0;
    var oElements;

    switch (g_nCurPage) {
        case PAGE_CONDITIONS:
            oElements = window.external.getConditions();
            break;
        case PAGE_ACTIONS:
            oElements = window.external.getActions();
            break;
        case PAGE_EXCEPTIONS:
            oElements = window.external.getExceptions();
            break;
    }
    
    if (oElements.count < 2) {
        return ncbNext;
    }

    var oElement, nAppliesTo, ncbPrev=ncbCur;
	var oRule = window.external.getSessionRule();
    var nApplyOn = oRule.applyOn;
    oElements = new Enumerator(oElements);
    for (;!oElements.atEnd();oElements.moveNext()) {
        oElement = oElements.item();
        nAppliesTo = oElement.appliesTo;
        
        if (kseOnReceive==nApplyOn) {
            if (kateOnReceive==nAppliesTo || kateAgnostic==nAppliesTo) {
                if (CBID_NEXT==nFlag) {
                    if (oElement.id>ncbCur) {
                        ncbNext = oElement.id;
                        break;
                    }
                }
                else if (CBID_PREV==nFlag) {
                    if (oElement.id==ncbCur && ncbPrev!=ncbCur) {
                        ncbNext = ncbPrev;
                        break;
                    }
                    ncbPrev = oElement.id;
                }
                else if (0==ncbNext) {
                    ncbNext = oElement.id;
                    break;
                }
            }
        }
        if (kseOnSend==nApplyOn) {
            if (kateOnSend==nAppliesTo || kateAgnostic==nAppliesTo) {
                if (CBID_NEXT==nFlag) {
                    if (oElement.id>ncbCur) {
                        ncbNext = oElement.id;
                        break;
                    }
                }
                else if (CBID_PREV==nFlag) {
                    if (oElement.id==ncbCur && ncbPrev!=ncbCur) {
                        ncbNext = ncbPrev;
                        break;
                    }
                    ncbPrev = oElement.id;
                }
                else if (0==ncbNext) {
                    ncbNext = oElement.id;
                    break;
                }
            }        
        }
    }
    
    return ncbNext;
}

function elementsOnKeyDown() {
    switch (event.keyCode) {
        case VK_ESCAPE:
            btn_cancel_onclick();
            break;
        case VK_TAB: {
            var sID = event.srcElement.id;
            if ("cb"==sID.substr(0,2)) {
                if (!event.shiftKey) {
                    document.all("btnCancel").focus();
                }
                else {
                    document.all("btnDone").focus();
                }
                event.keyCode = 0;
                break;
            }
            switch (sID) {
                case "btnDone":
                    if (!event.shiftKey) {
                        var ncb = getNextCBID(1, CBID_FIRST);
                        var ocb = document.all("cb" + ncb);
                        if (ocb!=null) {
                            ocb.focus();
                            event.keyCode = 0;
                        }
                    }
                    break;
                case "btnCancel":
                    if (event.shiftKey) {
                        var ncb = getNextCBID(1, CBID_FIRST);
                        var ocb = document.all("cb" + ncb);
                        if (ocb!=null) {
                            ocb.focus();
                            event.keyCode = 0;
                        }
                    }
                    break;
            }
        }
            break;
        case VK_UP:
        case VK_DOWN: {
            var sID = event.srcElement.id;
            if ("cb"==sID.substr(0,2)) {
                var ncb = getDigits(sID);
                var ncbNext = getNextCBID(ncb, (event.keyCode==VK_DOWN?CBID_NEXT:CBID_PREV));
                if (ncbNext) {
                    var ocb = document.all("cb" + ncbNext);
                    if (ocb!=null) {
                        ocb.focus();
                        event.keyCode = 0;
                    }
                }
            }
        }
            break;
    }
}

function ruleslistOnKeyDown() {
    switch (event.keyCode) {
        case VK_ESCAPE:
            onclickCancelChanges();
            break;
        case VK_DELETE:
            if (selectedRow==event.srcElement) {
                DeleteRule();
            }
            break;
        case VK_RETURN:
            if (selectedRow==event.srcElement) {
                EditRule();
            }
            break;
        case VK_SPACE: 
            if (selectedRow==event.srcElement) {
    			var nRowID = getDigits(selectedRow.id);
                var ocb = document.all("cb" + nRowID);
                if (ocb!=null) {
                    ocb.checked = !ocb.checked;
                    EnableRule(ocb.id);
                }
            }
            break;
        case VK_DOWN: 
            if (selectedRow==event.srcElement) {
    			var nRowID = getDigits(selectedRow.id);
                if (nRowID < oRules.count) {
                    var oRow = document.all("row" + ++nRowID);
                    if (oRow!=null)
                        SelectRow(oRow);
                }
            }
            break;
        case VK_UP: 
            if (selectedRow==event.srcElement) {
                var nRowID = getDigits(selectedRow.id);
                if (nRowID > 1) {
                    var oRow = document.all("row" + --nRowID);
                    if (oRow!=null)
                        SelectRow(oRow);
                }
            }
            break;
        case VK_TAB: {
            // handle tab from any row in list control
            if (selectedRow==event.srcElement) {
                if (event.shiftKey) {
                    document.all("btnSaveChanges").focus();
                }
                else {
                    document.all("btnNewRule").focus();
                }
                event.keyCode = 0;
                break;
            }
            // if not from row in list, check other static controls
            switch (event.srcElement.id) {
                case "btnMoveDown":
                    if (!event.shiftKey) {
                        document.all("btnSaveChanges").focus();
                        event.keyCode = 0;
                    }
                    break;
                case "btnNewRule":
                    if (event.shiftKey) {
                        if (0==oRules.count) {
                            document.all("btnCancelChanges").focus();
                            event.keyCode = 0;
                        }
                        else if (selectedRow!=null) {
                            selectedRow.focus();
                            event.keyCode = 0;
                        }
                    }
                    break;
                case "btnCancelChanges":
                    if (!event.shiftKey) {
                        if (0==oRules.count) {
                            document.all("btnNewRule").focus();
                            event.keyCode = 0; // cancel the event
                        }
                        else if (selectedRow!=null) {
                            selectedRow.focus();
                            event.keyCode = 0; // cancel the event
                        }
                    }
                    break;
                case "btnSaveChanges":
                    if (event.shiftKey) {
                        document.all("btnMoveDown").focus();
                        event.keyCode = 0;
                    }
                    break;
            }
        }
            break;
        default:
            //document.all("ruleDetails").innerHTML = event.keyCode.toString(16);
    }
}

function setupOnKeyDown() {
    switch (event.keyCode) {
        case VK_ESCAPE:
            btn_cancel_onclick();
            break;
        case VK_TAB: {
            switch (event.srcElement.id) {
                case "ruleName":
                    if (event.shiftKey) {
                        document.all("btnDone").focus();
                        event.keyCode = 0;
                    }
                    break;
                case "enableRule":
                    if (!event.shiftKey) {
                        document.all("btnCancel").focus();
                        event.keyCode = 0;
                    }
                    break;
                case "btnDone":
                    if (!event.shiftKey) {
                        document.all("ruleName").focus();
                        document.all("ruleName").select();
                        event.keyCode = 0; // cancel the event
                    }
                    break;
                case "btnCancel":
                    if (event.shiftKey) {
                        document.all("enableRule").focus();
                        event.keyCode = 0;
                    }
                    break;
            }
        }
            break;
    }
}

//
// Hook keyDown event for the whole document 
//
document.onkeydown = docOnKeyDown;
function docOnKeyDown() {
    //alert("KeyDownHandler");
    //var n = event.keyCode;
    switch (g_nCurPage) {
        case PAGE_ACTIONS:
        case PAGE_CONDITIONS:
        case PAGE_EXCEPTIONS:
            elementsOnKeyDown();
            break;
        case PAGE_RULESLIST:
            ruleslistOnKeyDown();
            break;
        case PAGE_SETUP:
            setupOnKeyDown();
            break;
        default:
            alert("Error: docOnKeyDown - Current page is invalid.");
    }
}

